/*  2012 Matthias Linder (http://matthiaslinder.com) */
/* - Use as you feel fit, but leave this copyright. - */
using System;

namespace Hardware.GPS.Extensions
{
    /// <summary>
    /// Char extensions
    /// </summary>
    static class CharExtensions
    {
        /// <summary>
        /// Parses the specified character as a hex value
        /// </summary>
        /// <param name="c"></param>
        /// <returns></returns>
        public static int AsHex(this char c)
        {
            if (c >= '0' && c <= '9')
                return c - '0';
            if (c >= 'A' && c <= 'F')
                return c - 'A' + 10;
            if (c >= 'a' && c <= 'f')
                return c - 'a' + 10;
            throw new ArgumentException("Invalid Hex value: " + c);
        }
    }
}

