/*  2012 Matthias Linder (http://matthiaslinder.com) */
/* - Use as you feel fit, but leave this copyright. - */

namespace Hardware.GPS.Helpers
{
    /// <summary>
    /// Utility class
    /// </summary>
    static class Utils
    {
        /// <summary>
        /// Parses the specified number as Bits, e.g. 11 -> 3
        /// </summary>
        /// <param name="num"></param>
        /// <returns></returns>
        public static byte BitMask(int num)
        {
            int bits = 0;
            for (int i = 7; i >= 0; i--)
                bits |= BitSet(ref num, i);
            return (byte)bits;
        }

        /// <summary>
        /// Returns the bitmask for the specified bit num, and subtracts it from num (if set)
        /// </summary>
        /// <param name="num"></param>
        /// <param name="bitNum"></param>
        /// <returns></returns>
        private static int BitSet(ref int num, int bitNum)
        {
            int result = (1 << bitNum);
            int testNum = 1;
            while (bitNum-- > 0) testNum *= 10;
            if (num >= testNum)
            {
                num -= testNum;
                return result;
            }
            return 0;
        }
    }
}

