﻿/* © 2012 Matthias Linder (http://matthiaslinder.com) */
/* - Use as you feel fit, but leave this copyright. - */

using System;
using System.IO.Ports;
using System.Text;
using System.Threading;
using Hardware.GPS;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

namespace TestProject
{
    /// <summary>
    /// GPS Test Project
    /// </summary>
    public class Program
    {
        public static void Main()
        {
            Debug.Print("Hello, GPS!");
            Thread.Sleep(2000);
            Debug.Print("Initialising GPS and serial port...");

            // Open Serial port to GPS module
            var gps = new CN06GPS("COM3", false)
                          {
                              Rate = 1000,
                              NavModel = CN06GPS.DynNavModel.Portable,
                          };
            var port = new SerialPort("COM2") // can e.g. be connected to bluetooth, or just removed
                           {
                               BaudRate = 9600,
                               Handshake = Handshake.None
                           };
            port.Open();

            while (true)
            {
                // Print the current GPS status
                string msg = gps.ToString();

                Debug.Print(msg);
                byte[] buf = Encoding.UTF8.GetBytes(msg + "\n");
                port.Write(buf, 0, buf.Length);
                port.Flush();

                // Update the system time using the GPS
                if (gps.DateTime > DateTime.UtcNow)
                    Utility.SetLocalTime(gps.DateTime);

                Thread.Sleep(1000);
            }
        }
    }
}
